@echo off
:: bldrel - Build NowhereTools release zip file
:: Optional arguments passed to zip
:: Default is -f9o

:: Copyright (c) 2009 Steven Levine and Associates, Inc.
:: All rights reserved.

:: This program is free software licensed under the terms of the GNU
:: General Public License.  The GPL Software License can be found in
:: gnugpl2.txt or at http://www.gnu.org/licenses/licenses.html#GPL

:: 02 Nov 09 SHL Baseline

if "%@eval[0]" == "0" goto is4xxx
  echo Must run in 4OS2 session
  pause
  goto eof
:is4xxx

loadbtm on
on errormsg pause
on break @goto Halted
setlocal

if "%_DOS%" != "OS2" ( echo Must run in 4OS2 session %+ beep %+ cancel )

set ME=%@filename[%0]

set REL=0.1
set TS=20%@substr[%_DATE,6,2]%@substr[%_DATE,0,2]%@substr[%_DATE,3,2]

set ZF=NowhereTools-%REL-%TS.zip

iff exist %ZF then
  call askyn Overwrite %ZF
  if %? != 0 cancel
endiff

set OPT=

iff "%1" != "" then
  iff "%@substr[%1,0,1]" == "-" then
    set OPT=%1 -9o
    shift /1
  endiff
endiff

iff "%OPT" == "" then
  iff exist %ZF then
    set OPT=-f9o
  else
    set OPT=-u9o
  endiff
endiff

iff "%1" == "" then
 set WC=*.cmd *.txt
else
  set WC=%$
endiff

:: 4OS2 style
set WC2=%@replace[ ,;,%WC]

echo on
shlcpy -pfu ..\* .\
@echo off
for %X in ( %WC ) (
  iff %@attrib[%X,R] == 1 then
    echo attrib -r %X
    attrib -r %X
  endiff
  echo eautil %X nul /s
  eautil %X nul /s
  @echo off
  iff %@attrib[%X,A] == 1 then
    echo attrib -a %X
    attrib -a %X
  endiff
)

set ZX=zip
set UZX=unzip

%ZX %OPT %ZF %WC -x *.zip -x %ME
@echo off

:: Clear archive bits of zip files - fixme to be gone?
echo.
set WF=%@unique[%TMP]
%UZX -Z1 %ZF >%WF
for %X in ( @%WF ) (
  iff exist %X then
    iff %@attrib[%X,A] == 1 then
      echo on
      attrib -a %X
      @echo off
    endiff
  endiff
)
del /q %WF
set WF=

echo.
echo on
dir /h /m /t
@echo.
%UZX -v %ZF
@echo off

echo.
dir /f %ZF >clip:
echo %ZF written to clipboard

quit

::=== Halted() Handle break ===

:Halted
  @echo off
  echo Halted by user
  :: gosub Cleanup
  cancel
  :: end Halted

:eof
